/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.thin.sample.service.blogic;

import java.util.HashMap;
import java.util.Map;

import jp.terasoluna.fw.dao.QueryDAO;
import jp.terasoluna.fw.service.thin.BLogic;
import jp.terasoluna.fw.service.thin.BLogicResult;
import jp.terasoluna.sample.commons.ZandakaData;


/**
 * "残高テーブル"からデータを取得し、一覧表示リストを生成するビジネスロジッククラス。
 *
 */
public class ListBLogicImpl implements BLogic<Map<String, String>> {

    /**
     * DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    private QueryDAO queryDAO = null;

    /**
     * QueryDAOを返却する。
     *
     * @return 保持するQueryDAO
     */
    public QueryDAO getQueryDAO() {
        return queryDAO;
    }

    /**
     * QueryDAOを設定する。
     *
     * @param dao 設定するQueryDAO
     */
    public void setQueryDAO(QueryDAO dao) {
        this.queryDAO = dao;
    }
    
    
    /**
     * 残高リストを返却する。
     * @param map ページ情報を保持したマップ
     * @return 残高リスト
     */
    public Map<String, Object> getZandakaList(Map<String, String> map) {

        String strIndex = map.get("startIndex");
        String strRow = map.get("row");
        
        //取得件数の設定
        int startIndex = 0;
        int row = 20;
        if (strIndex != null) {
            try {
                startIndex = Integer.parseInt(strIndex);
            } catch (NumberFormatException e) {
                startIndex = 0;
            }
        }
        if (strRow != null) {
            try {
                row = Integer.parseInt(strRow);
            } catch (NumberFormatException e) {
                row = 20;
            }
        }
        
    	//残高取得処理
    	//残高テーブルから画面に表示する件数分の残高データを顧客IDの昇順で取得する    
       	ZandakaData[] zandakaDatas = queryDAO.executeForObjectArray("Sample.getZandakaDataList", null, ZandakaData.class, startIndex, row);
       	
    	//取得情報返却処理
    	//取得情報『顧客ＩＤ』、『残高』、『最終取引日』を返却する。
        Map<String, Object> retMap = new HashMap<String, Object>();

        retMap.put("totalCount", getTotalCount());
        retMap.put("zandakaDatas", zandakaDatas);

        return retMap;

    }
    
    /**
     * ビジネスロジックを実行する。
     * @param map ページ情報を保持したマップ
     * @return ビジネスロジック結果
     */
    public BLogicResult execute(Map<String, String> map) {
        //BLogicResultの生成、結果の設定
        //ビジネスロジックの実行、結果の取得
        Map<String, Object> retMap = getZandakaList(map);
        BLogicResult result = new BLogicResult();
        result.setResultString("success");
        result.setResultObject(retMap);
        return result;
        
    }
    
    /**
     * 一覧情報の全件数を取得して返却する。
     *
     * @return 取得した件数文字列
     */
    public String getTotalCount() {

        String count
            = queryDAO.executeForObject("Sample.getZandakaDataCount", null, String.class);
        if (count == null || "".equals(count)) {
            count = "0";
        }
        return count;
        
    }

}
